SystemOrganization addCategory: #'Ice-Core'!
SystemOrganization addCategory: #'Ice-Core-Announcement'!

Trait named: #TICAnnouncer
	uses: {}
	category: 'Ice-Core'!

!TICAnnouncer methodsFor: 'accouncing' stamp: 'EstebanLorenzano 1/19/2011 11:39'!
announce: anAnnouncement 
	self announcer announce: anAnnouncement ! !

!TICAnnouncer methodsFor: 'accouncing' stamp: 'EstebanLorenzano 1/19/2011 11:39'!
announcer 
	^ICRepositoryManager uniqueInstance announcer ! !

!TICAnnouncer methodsFor: 'accouncing' stamp: 'EstebanLorenzano 1/19/2011 11:40'!
on: anAnnouncement do: aBlock
	self announcer on: anAnnouncement do: aBlock! !

!TICAnnouncer methodsFor: 'accouncing' stamp: 'EstebanLorenzano 1/19/2011 11:40'!
suspendAllAnnouncementsWhile: aBlock
	self announcer suspendAllWhile: aBlock  ! !

!TICAnnouncer methodsFor: 'accouncing' stamp: 'EstebanLorenzano 1/19/2011 11:40'!
unsubscribe: anObject
	self announcer unsubscribe: anObject  ! !

Trait named: #TICGeneratorAware
	uses: {}
	category: 'Ice-Core'!

!TICGeneratorAware methodsFor: 'accessing' stamp: 'EstebanLorenzano 1/17/2011 20:17'!
generator 
	^ICSourceGenerator default! !

!Metaclass methodsFor: '*Ice-Core' stamp: 'DeboraFortini 2/11/2012 15:49'!
category
	^ self theNonMetaClass category.! !

Announcer subclass: #ICAnnouncer
	instanceVariableNames: 'suspendAll'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ice-Core'!

!ICAnnouncer methodsFor: 'announce' stamp: 'EstebanLorenzano 1/19/2011 11:40'!
announce: anAnnouncement
	suspendAll ifTrue: [ ^anAnnouncement ].
	^super announce: anAnnouncement! !

!ICAnnouncer methodsFor: 'initialization' stamp: 'EstebanLorenzano 1/19/2011 11:40'!
initialize 
	super initialize.
	suspendAll := false.! !

!ICAnnouncer methodsFor: 'as yet unclassified' stamp: 'EstebanLorenzano 1/19/2011 11:40'!
suspendAllWhile: aBlock
	suspendAll := true.
	aBlock ensure: [ suspendAll := false ]! !

!FSFilesystem methodsFor: '*ice-core' stamp: 'DeboraFortini 9/12/2011 14:52'!
allFiles 
	^FSSelectVisitor breadthFirst: self root 
		select: [:entry | entry isFile].! !

!RemovedEvent methodsFor: '*ice-core-extensions' stamp: 'EstebanLorenzano 1/19/2011 12:04'!
iceAccept: aManager
	  aManager eventRemove: self! !

!AddedEvent methodsFor: '*ice-core-extensions' stamp: 'EstebanLorenzano 1/19/2011 12:04'!
iceAccept: aManager
	  aManager eventAdd: self.! !

!FSReference methodsFor: '*Ice-core' stamp: 'DeboraFortini 2/11/2012 18:15'!
asFileSystemReference
	^ self! !

!AbstractEvent methodsFor: '*ice-core-extensions' stamp: 'EstebanLorenzano 1/19/2011 12:05'!
iceAccept: aManager
	  aManager eventUpdate: self.! !

Announcement subclass: #ICAnnouncement
	instanceVariableNames: 'repository'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ice-Core-Announcement'!

!ICAnnouncement class methodsFor: 'instance creation' stamp: 'EstebanLorenzano 1/19/2011 11:43'!
repository: aRepository 
	^self new 
		repository: aRepository;
		yourself    ! !

!ICAnnouncement methodsFor: 'accessing' stamp: 'EstebanLorenzano 1/19/2011 11:43'!
repository
	^ repository! !

!ICAnnouncement methodsFor: 'accessing' stamp: 'EstebanLorenzano 1/19/2011 11:43'!
repository: anObject
	repository := anObject! !

ICAnnouncement subclass: #ICContainerAddedAnnouncement
	instanceVariableNames: 'container'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ice-Core-Announcement'!

!ICContainerAddedAnnouncement class methodsFor: 'instance creation' stamp: 'EstebanLorenzano 1/19/2011 16:47'!
repository: aRepository container: aContainer
	^(self repository: aRepository)
		container: aContainer;
		yourself! !

!ICContainerAddedAnnouncement methodsFor: 'accessing' stamp: 'EstebanLorenzano 1/19/2011 16:47'!
container
	^ container! !

!ICContainerAddedAnnouncement methodsFor: 'accessing' stamp: 'EstebanLorenzano 1/19/2011 16:47'!
container: anObject
	container := anObject! !

ICAnnouncement subclass: #ICRepositoryAddedAnnouncement
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ice-Core-Announcement'!

ICAnnouncement subclass: #ICRepositoryRemovedAnnouncement
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ice-Core-Announcement'!

Object subclass: #ICChange
	instanceVariableNames: 'className classCategory'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ice-Core'!

!ICChange class methodsFor: 'instance creation' stamp: 'EstebanLorenzano 1/17/2011 10:22'!
className: nameString category: categoryString 
	^self basicNew 
		initializeClassName: nameString category: categoryString;
		yourself! !

!ICChange class methodsFor: 'instance creation' stamp: 'EstebanLorenzano 1/17/2011 10:22'!
new 
	self error: 'Use className:category:'! !

!ICChange methodsFor: 'applying' stamp: 'EstebanLorenzano 1/19/2011 10:42'!
applyOn: aRepository
	^self subclassResponsibility! !

!ICChange methodsFor: 'accessing' stamp: 'EstebanLorenzano 1/17/2011 10:20'!
classCategory
	^ classCategory! !

!ICChange methodsFor: 'accessing' stamp: 'EstebanLorenzano 1/17/2011 10:20'!
className 
	^className! !

!ICChange methodsFor: 'private' stamp: 'EstebanLorenzano 10/4/2011 15:49'!
fileOn: aReference
	^(aReference 
		/ self classCategory 
		/ self className) 
		withExtension: ICRepository fileExtension
	! !

!ICChange methodsFor: 'initialization' stamp: 'EstebanLorenzano 1/17/2011 10:21'!
initializeClassName: nameString category: categoryString
	self initialize.
	className := nameString.
	classCategory := categoryString.! !

ICChange subclass: #ICRemoveClassChange
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ice-Core'!

!ICRemoveClassChange methodsFor: 'applying' stamp: 'EstebanLorenzano 1/19/2011 10:51'!
applyOn: aRepository
	| file |
	file := self fileOn: aRepository storage.
	file exists ifTrue: [ file delete ].
	aRepository removeHistoryAt: self className  
! !

ICChange subclass: #ICUpdateClassChange
	uses: TICGeneratorAware
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ice-Core'!

ICUpdateClassChange class
	uses: TICGeneratorAware classTrait
	instanceVariableNames: ''!

!ICUpdateClassChange methodsFor: 'applying' stamp: 'EstebanLorenzano 1/19/2011 11:25'!
applyOn: aRepository
	| file |
	file := self fileOn: aRepository storage.
	file parent ensureDirectory.
	file fileStreamDo: [ :stream | stream nextPutAll: self source ].
	aRepository 
		historyAt: self className
		put: file entry modification asTimeStamp! !

!ICUpdateClassChange methodsFor: 'accessing' stamp: 'EstebanLorenzano 1/17/2011 13:02'!
source
 	^self generator sourceForClass: (Smalltalk at: self className)! !

ICUpdateClassChange subclass: #ICUpdateExtensionsChange
	instanceVariableNames: 'packages'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ice-Core'!

!ICUpdateExtensionsChange class methodsFor: 'instance creation' stamp: 'EstebanLorenzano 1/17/2011 13:13'!
className: nameString category: categoryString packages: aCollection
	^self basicNew 
		initializeClassName: nameString 
			category: categoryString
			packages: aCollection;
		yourself! !

!ICUpdateExtensionsChange methodsFor: 'initialization' stamp: 'EstebanLorenzano 1/17/2011 13:13'!
initializeClassName: nameString category:  categoryString packages: aCollection
	self initializeClassName: nameString category: categoryString.
	packages := aCollection.! !

!ICUpdateExtensionsChange methodsFor: 'accessing' stamp: 'EstebanLorenzano 1/17/2011 13:12'!
packages 
	^packages! !

Object subclass: #ICChangeRecord
	instanceVariableNames: 'timeStamp'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ice-Core'!

!ICChangeRecord class methodsFor: 'instance creation' stamp: 'EstebanLorenzano 1/16/2011 13:49'!
for: anObject
	^self basicNew 
		initialize: anObject;
		yourself! !

!ICChangeRecord class methodsFor: 'instance creation' stamp: 'EstebanLorenzano 1/16/2011 13:50'!
new 
	self error: 'Use #for:'! !

!ICChangeRecord methodsFor: 'accessing' stamp: 'EstebanLorenzano 1/16/2011 16:27'!
classCategory
	^self subclassResponsibility! !

!ICChangeRecord methodsFor: 'accessing' stamp: 'EstebanLorenzano 1/16/2011 14:39'!
className 
	^self subclassResponsibility! !

!ICChangeRecord methodsFor: 'initialization' stamp: 'DeboraFortini 10/12/2011 22:25'!
createChange
	^ICUpdateClassChange className: self className  category: self classCategory. 
	! !

!ICChangeRecord methodsFor: 'initialization' stamp: 'EstebanLorenzano 1/16/2011 13:50'!
initialize
	super initialize.
	timeStamp := TimeStamp now.    ! !

!ICChangeRecord methodsFor: 'initialization' stamp: 'EstebanLorenzano 1/16/2011 13:50'!
initialize: anObject
	self subclassResponsibility  ! !

!ICChangeRecord methodsFor: 'testing' stamp: 'EstebanLorenzano 1/19/2011 16:16'!
isNew 
	^false! !

!ICChangeRecord methodsFor: 'testing' stamp: 'EstebanLorenzano 1/17/2011 09:29'!
isRemove 
	^false! !

!ICChangeRecord methodsFor: 'testing' stamp: 'EstebanLorenzano 1/17/2011 09:29'!
isUpdate 
	^self isRemove not! !

!ICChangeRecord methodsFor: 'testing' stamp: 'EstebanLorenzano 1/16/2011 15:07'!
sameAs: anAction
	^self subclassResponsibility! !

!ICChangeRecord methodsFor: 'accessing' stamp: 'EstebanLorenzano 1/16/2011 13:50'!
timeStamp 
	^timeStamp ! !

ICChangeRecord subclass: #ICClassChangeRecord
	instanceVariableNames: 'name category'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ice-Core'!

ICClassChangeRecord subclass: #ICAddClassChangeRecord
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ice-Core'!

!ICAddClassChangeRecord methodsFor: 'testing' stamp: 'EstebanLorenzano 1/19/2011 16:16'!
isNew 
	^true! !

!ICAddClassChangeRecord methodsFor: 'printing' stamp: 'EstebanLorenzano 9/30/2011 12:28'!
printOn: aStream
	aStream nextPutAll: 'Class added'! !

!ICClassChangeRecord methodsFor: 'accessing' stamp: 'EstebanLorenzano 1/16/2011 13:51'!
category 
	^category! !

!ICClassChangeRecord methodsFor: 'accessing' stamp: 'EstebanLorenzano 1/16/2011 16:27'!
classCategory 
	^self category! !

!ICClassChangeRecord methodsFor: 'accessing' stamp: 'EstebanLorenzano 1/16/2011 16:22'!
className 
	^self name! !

!ICClassChangeRecord methodsFor: 'initialization' stamp: 'EstebanLorenzano 1/16/2011 13:52'!
initialize: anObject
	name := anObject name.
	category := anObject category.
	self initialize.  ! !

!ICClassChangeRecord methodsFor: 'accessing' stamp: 'EstebanLorenzano 1/16/2011 13:51'!
name 
	^name! !

!ICClassChangeRecord methodsFor: 'testing' stamp: 'EstebanLorenzano 1/16/2011 16:22'!
sameAs: anAction
	^(self species = anAction species)
		and: [ self name = anAction name ]  ! !

ICClassChangeRecord subclass: #ICRemoveClassChangeRecord
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ice-Core'!

!ICRemoveClassChangeRecord methodsFor: 'testing' stamp: 'DeboraFortini 10/12/2011 22:15'!
addMatchingChangeForClass: aClassName andCategory:  aClassCategory
	^ICRemoveClassChange className: aClassName  category: aClassCategory 
! !

!ICRemoveClassChangeRecord methodsFor: 'testing' stamp: 'DeboraFortini 10/12/2011 22:24'!
createChange
	^ICRemoveClassChange className:  self className  category:  self classCategory. 
! !

!ICRemoveClassChangeRecord methodsFor: 'testing' stamp: 'EstebanLorenzano 1/17/2011 09:29'!
isRemove 
	^true! !

!ICRemoveClassChangeRecord methodsFor: 'printing' stamp: 'EstebanLorenzano 9/30/2011 12:28'!
printOn: aStream
	aStream nextPutAll: 'Class removed'! !

ICClassChangeRecord subclass: #ICUpdateClassChangeRecord
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ice-Core'!

!ICUpdateClassChangeRecord methodsFor: 'printing' stamp: 'EstebanLorenzano 9/30/2011 12:29'!
printOn: aStream
	aStream nextPutAll: 'Class updated'! !

ICChangeRecord subclass: #ICMethodChangeRecord
	instanceVariableNames: 'name category className classCategory'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ice-Core'!

ICMethodChangeRecord subclass: #ICAddMethodChangeRecord
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ice-Core'!

!ICAddMethodChangeRecord methodsFor: 'printing' stamp: 'EstebanLorenzano 9/30/2011 12:30'!
printOn: aStream
	aStream nextPutAll: ('#{1} added' format: {self name})! !

!ICMethodChangeRecord class methodsFor: 'as yet unclassified' stamp: 'DeboraFortini 2/12/2012 17:59'!
forClass: aClass selector: aSelector
	^ self for: (RGMethodDefinition realClass: aClass selector: aSelector).
! !

!ICMethodChangeRecord methodsFor: 'accessing' stamp: 'EstebanLorenzano 1/16/2011 16:21'!
category 
	^category! !

!ICMethodChangeRecord methodsFor: 'accessing' stamp: 'EstebanLorenzano 1/16/2011 16:21'!
classCategory 
	^classCategory ! !

!ICMethodChangeRecord methodsFor: 'accessing' stamp: 'EstebanLorenzano 1/16/2011 16:21'!
className 
	^className ! !

!ICMethodChangeRecord methodsFor: 'initialization' stamp: 'EstebanLorenzano 1/16/2011 16:35'!
initialize: aMethodReference
	name := aMethodReference methodSymbol.	
	category := aMethodReference category asLowercase asSymbol.
	className := aMethodReference classSymbol.
	classCategory := (Smalltalk at: className) category.
	self initialize.! !

!ICMethodChangeRecord methodsFor: 'accessing' stamp: 'EstebanLorenzano 1/16/2011 16:21'!
name 
	^name! !

!ICMethodChangeRecord methodsFor: 'testing' stamp: 'EstebanLorenzano 1/16/2011 16:21'!
sameAs: anAction
	^((self species = anAction species)
		and: [ self className = anAction className ])
		and: [ self name = anAction name ]  ! !

ICMethodChangeRecord subclass: #ICRemoveMethodChangeRecord
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ice-Core'!

!ICRemoveMethodChangeRecord methodsFor: 'printing' stamp: 'EstebanLorenzano 9/30/2011 12:30'!
printOn: aStream
	aStream nextPutAll: ('#{1} removed' format: {self name})! !

ICMethodChangeRecord subclass: #ICUpdateMethodChangeRecord
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ice-Core'!

!ICUpdateMethodChangeRecord methodsFor: 'printing' stamp: 'EstebanLorenzano 9/30/2011 12:30'!
printOn: aStream
	aStream nextPutAll: ('#{1} updated' format: {self name})! !

Object subclass: #ICContainer
	instanceVariableNames: 'timeStamp changeRecords'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ice-Core'!

!ICContainer class methodsFor: 'instance creation' stamp: 'EstebanLorenzano 1/16/2011 13:16'!
for: anObject 
	^self basicNew 
		initialize: anObject;
		yourself! !

!ICContainer class methodsFor: 'instance creation' stamp: 'EstebanLorenzano 1/16/2011 13:16'!
new 
	self error: 'Use #for:'! !

!ICContainer methodsFor: 'accessing' stamp: 'DeboraFortini 10/12/2011 18:03'!
addChangeRecord: aChangeRecord
	self flag: #todo. "Me parece que es mejor conservar toda la historia... pero no se"
	self removeAllRelatedActions: aChangeRecord.
	(self changeRecords 
		at: aChangeRecord className 
		ifAbsentPut: [ OrderedCollection new ])
		add: aChangeRecord.
	self touched.! !

!ICContainer methodsFor: 'accessing' stamp: 'DeboraFortini 10/4/2011 14:21'!
allChangeRecords 
	^self changeRecords values 
		inject: OrderedCollection new 
		into: [ :all :each | all addAll: each; yourself ]! !

!ICContainer methodsFor: 'accessing' stamp: 'DeboraFortini 10/4/2011 14:19'!
allClassNames
	^self changeRecords keys asSet! !

!ICContainer methodsFor: 'testing' stamp: 'DeboraFortini 10/12/2011 18:08'!
canContain: aChangeRecord
	^self subclassResponsibility
  ! !

!ICContainer methodsFor: 'accessing' stamp: 'DeboraFortini 10/4/2011 14:19'!
changeRecords
	^changeRecords ifNil: [ changeRecords := Dictionary new ]! !

!ICContainer methodsFor: 'accessing' stamp: 'DeboraFortini 10/18/2011 14:50'!
changeRecordsFor: aSymbol
	"Answers change records for class named aSymbol"
	^self changeRecords at: aSymbol! !

!ICContainer methodsFor: 'accessing' stamp: 'DeboraFortini 10/12/2011 22:48'!
effectiveChanges 
	| changes |
	changes := OrderedCollection new. 
	self changeRecords keysAndValuesDo: [ :className :classChangeRecords |
		changes add: (classChangeRecords last createChange ) ].
	^changes
			
! !

!ICContainer methodsFor: 'testing' stamp: 'EstebanLorenzano 1/19/2011 12:21'!
handleMethod: aMethodReference
	self subclassResponsibility! !

!ICContainer methodsFor: 'testing' stamp: 'DeboraFortini 2/12/2012 19:53'!
handlesClass: aClass
	self subclassResponsibility! !

!ICContainer methodsFor: 'as yet unclassified' stamp: 'EstebanLorenzano 1/16/2011 18:36'!
incorporate  ! !

!ICContainer methodsFor: 'initialization' stamp: 'EstebanLorenzano 1/16/2011 15:02'!
initialize 
	super initialize.
	self touched! !

!ICContainer methodsFor: 'initialization' stamp: 'EstebanLorenzano 1/16/2011 13:17'!
initialize: anObject
	self subclassResponsibility    ! !

!ICContainer methodsFor: 'testing' stamp: 'DeboraFortini 10/4/2011 14:19'!
isAdding: aString
	^(self changeRecords at: aString) anySatisfy: #isNew      ! !

!ICContainer methodsFor: 'testing' stamp: 'DeboraFortini 10/4/2011 14:19'!
isDirty 
	^self changeRecords notEmpty! !

!ICContainer methodsFor: 'testing' stamp: 'EstebanLorenzano 1/16/2011 15:01'!
isExtension 
	^false! !

!ICContainer methodsFor: 'testing' stamp: 'EstebanLorenzano 1/16/2011 15:04'!
isPackage
	^false  ! !

!ICContainer methodsFor: 'testing' stamp: 'DeboraFortini 10/4/2011 14:19'!
isRemoving: aString
	^(self changeRecords at: aString) anySatisfy: #isRemove! !

!ICContainer methodsFor: 'testing' stamp: 'DeboraFortini 10/4/2011 14:19'!
isUpdating: aString
	^(self changeRecords at: aString) noneSatisfy: [ :each | each isNew or: [ each isRemove ] ].    ! !

!ICContainer methodsFor: 'accessing' stamp: 'EstebanLorenzano 1/16/2011 15:03'!
name 
	^self subclassResponsibility! !

!ICContainer methodsFor: 'private' stamp: 'EstebanLorenzano 10/4/2011 15:51'!
referenceFor: className inRepository: aRepository
	^(aRepository storage 
		/ self name
		/ className)
		withExtension: ICRepository fileExtension! !

!ICContainer methodsFor: 'private' stamp: 'DeboraFortini 10/4/2011 14:19'!
removeAllRelatedActions: anAction
	| actionCollection |
	actionCollection := (self changeRecords at: anAction className ifAbsent: [ nil ]).
	actionCollection ifNil: [ ^self ].
	
	self changeRecords 
		at: anAction className 
		put: (actionCollection reject: [ :each | each sameAs: anAction ])
! !

!ICContainer methodsFor: 'accessing' stamp: 'DeboraFortini 10/12/2011 18:42'!
removeChangeRecord: aChangeRecord
	| classChangeRecords |
	
	classChangeRecords := (self changeRecords at: aChangeRecord className) reject: [ :each | each = aChangeRecord ].
	classChangeRecords 
		ifNotEmpty: [ self changeRecords at: aChangeRecord className put: classChangeRecords ] 
		ifEmpty: [ self changeRecords removeKey: aChangeRecord className ]! !

!ICContainer methodsFor: 'as yet unclassified' stamp: 'DeboraFortini 10/4/2011 13:15'!
reset 
	changeRecords := nil! !

!ICContainer methodsFor: 'accessing' stamp: 'EstebanLorenzano 10/4/2011 15:46'!
sourceFor: className inRepository: aRepository
	| reference |
	reference := self 
		referenceFor: className
		inRepository: aRepository.
	^reference exists 
		ifTrue: [ 
			reference 
				readStreamDo: [ :stream | stream contents asString ] ]
		ifFalse: [ nil ]! !

!ICContainer methodsFor: 'accessing' stamp: 'EstebanLorenzano 1/16/2011 13:24'!
timeStamp
	^timeStamp! !

!ICContainer methodsFor: 'private' stamp: 'EstebanLorenzano 1/16/2011 15:01'!
touched 
	timeStamp := TimeStamp now! !

ICContainer subclass: #ICExtensionContainer
	instanceVariableNames: 'repository'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ice-Core'!

!ICExtensionContainer methodsFor: 'testing' stamp: 'DeboraFortini 10/12/2011 18:53'!
canContain: aChangeRecord
	^self categoryMatch: aChangeRecord category  ! !

!ICExtensionContainer methodsFor: 'private' stamp: 'EstebanLorenzano 1/19/2011 12:42'!
categoryMatch: aSymbolOrString
	^(self packages 
		collect: [ :each | '*', each name asLowercase])
		anySatisfy: [ :each | each = aSymbolOrString or: [ aSymbolOrString beginsWith: each, '-' ] ]    	  ! !

!ICExtensionContainer methodsFor: 'accessing' stamp: 'DeboraFortini 10/12/2011 20:48'!
effectiveChanges 
	| changes packages |
	packages := self packages.
	changes := OrderedCollection new. 
	self changeRecords keysAndValuesDo: [ :className :classChangeRecords |
		changes add: (ICUpdateExtensionsChange 
			className: className 
			category: self name
			packages: packages) ].
	^changes! !

!ICExtensionContainer methodsFor: 'testing' stamp: 'DeboraFortini 9/24/2011 20:55'!
handlesClass: aClass 
	"Extension package does not handle classes (just methods)"
	^false  ! !

!ICExtensionContainer methodsFor: 'testing' stamp: 'DeboraFortini 10/2/2011 19:57'!
handlesMethod: aMethodReference  
	^self categoryMatch: aMethodReference category! !

!ICExtensionContainer methodsFor: 'as yet unclassified' stamp: 'DeboraFortini 10/12/2011 18:42'!
incorporate: aPackage 
	| packageNames |
	"Remove pre-saved actions who no longer corresponds to this place.
	 Then adds all the method extensions from this package"

	(self allChangeRecords select: [ :each | aPackage canContain: each  ]) 
		do: [ :each | self removeChangeRecord: each ].
	
	packageNames := self packages collect: #name.
	(aPackage packageInfo extensionMethods
		reject: [ :each | packageNames includes: (Smalltalk at: each classSymbol) category ])
		do: [ :each | self addChangeRecord: (ICAddMethodChangeRecord for: each)  ]! !

!ICExtensionContainer methodsFor: 'initialization' stamp: 'EstebanLorenzano 1/16/2011 14:19'!
initialize: aRepository
	repository := aRepository.
	self initialize.! !

!ICExtensionContainer methodsFor: 'testing' stamp: 'EstebanLorenzano 1/16/2011 14:18'!
isExtension 
	^true! !

!ICExtensionContainer methodsFor: 'accessing' stamp: 'EstebanLorenzano 1/16/2011 15:05'!
name
	^'Extensions'! !

!ICExtensionContainer methodsFor: 'accessing' stamp: 'EstebanLorenzano 1/16/2011 17:43'!
packages 
	^repository containers select: [ :each | each isExtension not ]! !

ICContainer subclass: #ICPackageContainer
	instanceVariableNames: 'name'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ice-Core'!

!ICPackageContainer methodsFor: 'testing' stamp: 'DiogenesMoreira 2/22/2011 19:46'!
= other
	 [ ^ self name = other name ] ifError:[ ^ false ]! !

!ICPackageContainer methodsFor: 'testing' stamp: 'DeboraFortini 10/12/2011 18:54'!
canContain: aChangeRecords
	^self categoryMatch: aChangeRecords classCategory  ! !

!ICPackageContainer methodsFor: 'private' stamp: 'EstebanLorenzano 1/19/2011 12:27'!
categoryMatch: aSymbolOrString
	^(aSymbolOrString = self name) 
		or: [ aSymbolOrString beginsWith: self name, '-' ]  ! !

!ICPackageContainer methodsFor: 'accessing' stamp: 'DeboraFortini 10/12/2011 20:48'!
effectiveChanges 
	| changes |
	changes := OrderedCollection new. 
	self changeRecords keysAndValuesDo: [ :className :classChangeRecords |
		changes add: (classChangeRecords last isUpdate 
			ifTrue: [ 
				ICUpdateClassChange 
					className: className 
					category: classChangeRecords anyOne classCategory ]
			ifFalse: [ 
				ICRemoveClassChange 
					className: className 
					category: classChangeRecords anyOne classCategory ]) ].
	^changes! !

!ICPackageContainer methodsFor: 'testing' stamp: 'DeboraFortini 9/24/2011 20:55'!
handlesClass: aClass  
	^self categoryMatch: aClass category  ! !

!ICPackageContainer methodsFor: 'testing' stamp: 'DeboraFortini 10/2/2011 19:52'!
handlesMethod: aMethodReference
	^self handlesClass: aMethodReference actualClass 
	  ! !

!ICPackageContainer methodsFor: 'testing' stamp: 'DiogenesMoreira 2/22/2011 19:44'!
hash
	 ^ self name hash.! !

!ICPackageContainer methodsFor: 'as yet unclassified' stamp: 'DeboraFortini 10/4/2011 11:42'!
incorporate 
	self packageInfo classes 
		do: [ :each | self addChangeRecord: (ICAddClassChangeRecord for: each) ]! !

!ICPackageContainer methodsFor: 'initialization' stamp: 'EstebanLorenzano 1/16/2011 13:17'!
initialize: aPackageInfo
	name := aPackageInfo packageName. 
	self initialize! !

!ICPackageContainer methodsFor: 'testing' stamp: 'EstebanLorenzano 1/16/2011 15:04'!
isPackage
	^true! !

!ICPackageContainer methodsFor: 'accessing' stamp: 'EstebanLorenzano 1/16/2011 15:03'!
name 
	^name! !

!ICPackageContainer methodsFor: 'accessing' stamp: 'EstebanLorenzano 1/16/2011 17:33'!
packageInfo 
	^PackageOrganizer default 
		packageNamed: self name
		ifAbsent: [ self error: 'No package named ', self name, ' in system' ]! !

Object subclass: #ICMethodReference
	instanceVariableNames: 'methodSymbol classSymbol category'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ice-Core'!

!ICMethodReference class methodsFor: 'as yet unclassified' stamp: 'DeboraFortini 10/3/2011 15:16'!
for: anEvent
	^ self new
		methodSymbol: anEvent itemMethod selector;
		classSymbol: anEvent itemMethod methodClass theNonMetaClass name;
		category: (anEvent environmentAt: #protocol);
		yourself.
		
	 
	! !

!ICMethodReference methodsFor: 'accesing' stamp: 'DeboraFortini 10/3/2011 15:22'!
actualClass
	^Smalltalk at: self classSymbol.! !

!ICMethodReference methodsFor: 'accessing' stamp: 'DeboraFortini 10/3/2011 15:15'!
category
	^ category ifNil: [ category := 'as yet unclassified' asSymbol ]! !

!ICMethodReference methodsFor: 'accessing' stamp: 'DeboraFortini 10/3/2011 14:31'!
category: anObject
	category := anObject! !

!ICMethodReference methodsFor: 'accessing' stamp: 'DeboraFortini 10/3/2011 14:31'!
classSymbol
	^ classSymbol! !

!ICMethodReference methodsFor: 'accessing' stamp: 'DeboraFortini 10/3/2011 14:31'!
classSymbol: anObject
	classSymbol := anObject! !

!ICMethodReference methodsFor: 'accessing' stamp: 'DeboraFortini 10/3/2011 14:31'!
methodSymbol
	^ methodSymbol! !

!ICMethodReference methodsFor: 'accessing' stamp: 'DeboraFortini 10/3/2011 14:31'!
methodSymbol: anObject
	methodSymbol := anObject! !

Object subclass: #ICRepository
	uses: TICGeneratorAware + TICAnnouncer
	instanceVariableNames: 'containers storage history autopush'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ice-Core'!

ICRepository class
	uses: TICGeneratorAware classTrait + TICAnnouncer classTrait
	instanceVariableNames: ''!

!ICRepository class methodsFor: 'accessing' stamp: 'EstebanLorenzano 10/4/2011 15:49'!
fileExtension 
	^'st'! !

!ICRepository class methodsFor: 'instance creation' stamp: 'EstebanLorenzano 1/16/2011 17:09'!
new 
	self error: 'Use #on:'! !

!ICRepository class methodsFor: 'instance creation' stamp: 'EstebanLorenzano 1/16/2011 17:09'!
on: aFilesystemReference
	^self basicNew 
		initialize: aFilesystemReference;
		yourself! !

!ICRepository class methodsFor: 'accessing' stamp: 'EstebanLorenzano 1/17/2011 23:19'!
statusChanged
	^#changed! !

!ICRepository class methodsFor: 'accessing' stamp: 'EstebanLorenzano 1/17/2011 23:18'!
statusConflict
	^#conflict! !

!ICRepository class methodsFor: 'accessing' stamp: 'EstebanLorenzano 1/17/2011 23:18'!
statusOk
	^#ok! !

!ICRepository class methodsFor: 'accessing' stamp: 'EstebanLorenzano 1/17/2011 23:19'!
statusStorageChanged 
	^#storageChanged! !

!ICRepository methodsFor: 'accessing' stamp: 'DeboraFortini 2/12/2012 19:49'!
addChangeRecord: aChangeRecord
	(self containerWhoCanContain: aChangeRecord) addChangeRecord: aChangeRecord.
	self touchClassName: aChangeRecord className.
	self isAutopush ifTrue: [ aChangeRecord createChange applyOn: self ].! !

!ICRepository methodsFor: 'accessing' stamp: 'DeboraFortini 2/12/2012 20:20'!
addContainer: aContainer
	self containers add: aContainer.
	self incorporateContainer: aContainer.
	self announce: (ICContainerAddedAnnouncement 
		repository: self 
		container: aContainer).
	self isAutopush ifTrue: [ self push ].	! !

!ICRepository methodsFor: 'accessing' stamp: 'EstebanLorenzano 1/19/2011 15:56'!
addPackage: aPackageInfo
	self addContainer: (ICPackageContainer for: aPackageInfo)  ! !

!ICRepository methodsFor: 'accessing' stamp: 'EstebanLorenzano 1/19/2011 15:57'!
addPackageNamed: aString
	self addPackage: (PackageOrganizer default packages
		detect: [ :each | each packageName = aString ]).
! !

!ICRepository methodsFor: 'accessing' stamp: 'DeboraFortini 2/7/2012 18:06'!
changeRecords 
	^ self containers 
		inject: Set new 
		into: [ :all :each | all addAll: each allChangeRecords; yourself ]! !

!ICRepository methodsFor: 'private' stamp: 'EstebanLorenzano 1/16/2011 17:39'!
containerWhoCanContain: anAction
	^self containers detect: [ :each | each canContain: anAction ]  ! !

!ICRepository methodsFor: 'accessing' stamp: 'EstebanLorenzano 1/16/2011 18:38'!
containers
	^containers! !

!ICRepository methodsFor: 'private' stamp: 'DeboraFortini 11/21/2011 12:31'!
containersWithChangeRecords
	^self containers select: #isDirty! !

!ICRepository methodsFor: 'accessing' stamp: 'DeboraFortini 2/11/2012 16:00'!
disableAutopush
	autopush := false. ! !

!ICRepository methodsFor: 'private' stamp: 'DeboraFortini 10/12/2011 20:48'!
effectiveChanges 
	^self containersWithChangeRecords 
		gather: #effectiveChanges 
	! !

!ICRepository methodsFor: 'accessing' stamp: 'DeboraFortini 2/12/2012 20:19'!
enableAutopush
	autopush := true. 
	self push.! !

!ICRepository methodsFor: 'accessing' stamp: 'EstebanLorenzano 1/16/2011 17:40'!
extensionContainer
	^self containers detect: #isExtension! !

!ICRepository methodsFor: 'testing' stamp: 'DeboraFortini 9/24/2011 20:55'!
handlesClass: aClass
	^self containers anySatisfy: [ :each | each handlesClass: aClass ]! !

!ICRepository methodsFor: 'testing' stamp: 'DeboraFortini 10/2/2011 19:56'!
handlesMethod: aMethodReference
	^self containers anySatisfy: [ :each | each handlesMethod: aMethodReference ]! !

!ICRepository methodsFor: 'accessing' stamp: 'EstebanLorenzano 1/17/2011 10:25'!
history 
	^history ifNil: [ history := Dictionary new ]! !

!ICRepository methodsFor: 'accessing' stamp: 'EstebanLorenzano 1/17/2011 20:14'!
historyAt: aSymbol
	^self history 
		at: aSymbol 
		ifAbsent: [ nil ]! !

!ICRepository methodsFor: 'accessing' stamp: 'EstebanLorenzano 1/19/2011 10:44'!
historyAt: aSymbol put: aTimeStamp
	^self history 
		at: aSymbol 
		put: aTimeStamp! !

!ICRepository methodsFor: 'private' stamp: 'EstebanLorenzano 1/19/2011 08:29'!
incorporateContainer: aContainer
	self 
		assert: aContainer isExtension not
		description: 'You can''t incorporate extensions container'.
	aContainer incorporate.
	self extensionContainer incorporate: aContainer.
	(aContainer allClassNames, self extensionContainer allClassNames)
		do: [ :each | self history at: each ifAbsentPut: [ TimeStamp now ] ].! !

!ICRepository methodsFor: 'initialization' stamp: 'DeboraFortini 2/11/2012 16:01'!
initialize 
	super initialize.
	autopush := false.
	containers := Set with: (ICExtensionContainer for: self)! !

!ICRepository methodsFor: 'initialization' stamp: 'EstebanLorenzano 1/16/2011 17:09'!
initialize: aFilesystemReference 
	storage := aFilesystemReference.
	self initialize  ! !

!ICRepository methodsFor: 'accessing' stamp: 'DeboraFortini 2/11/2012 15:59'!
isAutopush
	^ autopush! !

!ICRepository methodsFor: 'testing' stamp: 'EstebanLorenzano 1/16/2011 17:37'!
isDirty
	^self containers anySatisfy: #isDirty  ! !

!ICRepository methodsFor: 'private' stamp: 'EstebanLorenzano 1/17/2011 23:18'!
lastInternalTimeStamp
	^ self history  
		ifNotEmpty: [ self history values max ] 
		ifEmpty: [ nil ]! !

!ICRepository methodsFor: 'private' stamp: 'DeboraFortini 11/21/2011 10:14'!
lastStorageTimeStamp
	^ self storageEntries 
		ifNotEmpty: [ :entries| 
			(entries collect: #modification) max asTimeStamp  ] 
		ifEmpty: [ nil ]! !

!ICRepository methodsFor: 'accessing' stamp: 'EstebanLorenzano 1/17/2011 22:08'!
name 
	^self storage asString! !

!ICRepository methodsFor: 'printing' stamp: 'EstebanLorenzano 1/17/2011 22:08'!
printOn: aStream 
	aStream nextPutAll: self name! !

!ICRepository methodsFor: 'operations' stamp: 'EstebanLorenzano 1/19/2011 11:05'!
pull 
	self storageNewerEntries do: [ :each |
		each reference readStreamDo: [ :stream | 
			self generator installSource: stream contents asString ] ].
	self reset.! !

!ICRepository methodsFor: 'operations' stamp: 'DeboraFortini 10/12/2011 20:48'!
push 
	self effectiveChanges do: [ :each | each applyOn: self ].
	self reset.! !

!ICRepository methodsFor: 'accessing' stamp: 'EstebanLorenzano 1/19/2011 10:51'!
removeHistoryAt: aSymbol
	^self history removeKey: aSymbol ifAbsent: []
		! !

!ICRepository methodsFor: 'private' stamp: 'EstebanLorenzano 1/19/2011 11:05'!
reset 
	self containers do: #reset! !

!ICRepository methodsFor: 'accessing' stamp: 'EstebanLorenzano 1/19/2011 10:26'!
status
	| internalChanged storageChanged storageLastDate internalLastDate |

	internalChanged := false.
	storageChanged := false.
	internalLastDate := self lastInternalTimeStamp.
	storageLastDate := self lastStorageTimeStamp.	
	
	(internalLastDate isNil and: [ storageLastDate isNil ]) ifTrue: [ ^self class statusOk ]. 
	(internalLastDate notNil and: [ storageLastDate isNil ]) ifTrue: [ ^self class statusChanged ].	
	(internalLastDate isNil and: [ storageLastDate notNil ]) ifTrue: [ ^self class statusStorageChanged ].
	
	self isDirty ifTrue: [ internalChanged := true ].
	(internalLastDate > storageLastDate) ifTrue: [ internalChanged := true ].
	(internalLastDate < storageLastDate) ifTrue: [ storageChanged := true ]. 
	
	(internalChanged and: [ storageChanged not ]) ifTrue: [ ^self class statusChanged ].
	(internalChanged not and: [ storageChanged ]) ifTrue: [ ^self class statusStorageChanged ].
	(internalChanged and: [ storageChanged]) ifTrue: [ ^self class statusConflict ].
	
	^self class statusOk! !

!ICRepository methodsFor: 'private' stamp: 'EstebanLorenzano 1/16/2011 17:08'!
storage 
	^storage! !

!ICRepository methodsFor: 'private' stamp: 'DeboraFortini 2/11/2012 17:09'!
storageEntries 
	"Answer a collection of entries for all files in repository"
	^(self storage allEntries )
		select: [ :each | each isFile and: [ each extension = self class fileExtension ]].! !

!ICRepository methodsFor: 'private' stamp: 'EstebanLorenzano 1/17/2011 23:15'!
storageNewerEntries 
	^self storageEntries 
		select: [ :each | 
			| lastImageModification lastModification |
			lastImageModification := self historyAt: (each basename copyUpTo: $.) asSymbol. 
			lastModification := each modification.
			lastImageModification isNil or: [ lastImageModification < lastModification ] ]! !

!ICRepository methodsFor: 'private' stamp: 'EstebanLorenzano 1/19/2011 10:46'!
touchClassName: aString
	self history 
		at: aString 
		put: TimeStamp now! !

Object subclass: #ICRepositoryManager
	uses: TICAnnouncer
	instanceVariableNames: 'repositories announcer'
	classVariableNames: 'UniqueInstance'
	poolDictionaries: ''
	category: 'Ice-Core'!

ICRepositoryManager class
	uses: TICAnnouncer classTrait
	instanceVariableNames: ''!

!ICRepositoryManager class methodsFor: 'instance creation' stamp: 'EstebanLorenzano 1/16/2011 16:59'!
new 
	self error: 'Use #uniqueInstance'! !

!ICRepositoryManager class methodsFor: 'instance creation' stamp: 'EstebanLorenzano 1/16/2011 16:57'!
uniqueInstance 
	^UniqueInstance ifNil: [ UniqueInstance := self basicNew initialize ]! !

!ICRepositoryManager methodsFor: 'private' stamp: 'DeboraFortini 10/4/2011 11:42'!
addClass: aClass 
	(self repositories 
		select: [ :each | each handlesClass: aClass ])
		do: [ :each | each addChangeRecord: (ICAddClassChangeRecord for: aClass) ]! !

!ICRepositoryManager methodsFor: 'private' stamp: 'DeboraFortini 10/4/2011 11:42'!
addMethod: aMethodReference
	(self repositories 
		select: [ :each | each handlesMethod: aMethodReference ])
		do: [ :each | each addChangeRecord: (ICAddMethodChangeRecord for: aMethodReference) ]	! !

!ICRepositoryManager methodsFor: 'accessing' stamp: 'EstebanLorenzano 1/19/2011 16:09'!
addRepository: aRepository
	self repositories add: aRepository.
	self announce: (ICRepositoryAddedAnnouncement repository: aRepository).
	^aRepository! !

!ICRepositoryManager methodsFor: 'accessing' stamp: 'EstebanLorenzano 1/18/2011 09:12'!
addRepositoryOn: aFilesystemReference
	self addRepository: (ICRepository on: aFilesystemReference)  ! !

!ICRepositoryManager methodsFor: 'accessing' stamp: 'DeboraFortini 2/11/2012 18:16'!
addRepositoryOnDirectory: aString
	^self addRepository: (ICRepository on: (aString asFileSystemReference))! !

!ICRepositoryManager methodsFor: 'accouncing' stamp: 'EstebanLorenzano 1/19/2011 11:41'!
announcer 
	^announcer ifNil: [ announcer := ICAnnouncer new ]! !

!ICRepositoryManager methodsFor: 'sources, change log' stamp: 'EstebanLorenzano 1/19/2011 11:52'!
event: anEvent
	anEvent iceAccept: self  ! !

!ICRepositoryManager methodsFor: 'sources, change log' stamp: 'DeboraFortini 2/12/2012 17:00'!
eventAdd: anEvent
	anEvent itemKind = #class ifTrue: [ self addClass: anEvent itemClass ].
	anEvent itemKind = #method ifTrue: [ self addMethod: anEvent itemMethod asRingDefinition ].

	! !

!ICRepositoryManager methodsFor: 'sources, change log' stamp: 'DeboraFortini 10/3/2011 14:32'!
eventRemove: anEvent
	
	anEvent itemKind = #class ifTrue: [ self removeClass: anEvent itemClass ].
	anEvent itemKind = #method ifTrue: [ 
		| reference |
		reference := ICMethodReference for: anEvent.
  
		self removeMethod: reference ].
 ! !

!ICRepositoryManager methodsFor: 'sources, change log' stamp: 'DeboraFortini 10/3/2011 15:09'!
eventUpdate: anEvent
	
	anEvent itemKind = #class ifTrue: [ self updateClass: anEvent itemClass ].
	anEvent itemKind = #method ifTrue: [ self updateMethod: (ICMethodReference for: anEvent )].
 ! !

!ICRepositoryManager methodsFor: 'initialization' stamp: 'EstebanLorenzano 1/19/2011 11:53'!
initialize 
	super initialize.
	self registerForListenEvents.
	repositories := OrderedCollection new. ! !

!ICRepositoryManager methodsFor: 'initialization' stamp: 'EstebanLorenzano 1/19/2011 11:53'!
registerForListenEvents
	SystemChangeNotifier uniqueInstance 
		notify: self
		ofAllSystemChangesUsing: #event:! !

!ICRepositoryManager methodsFor: 'accessing' stamp: 'EstebanLorenzano 1/17/2011 22:09'!
removeAllRepositories
	repositories := OrderedCollection new! !

!ICRepositoryManager methodsFor: 'private' stamp: 'DeboraFortini 10/4/2011 11:42'!
removeClass: aClass 
	(self repositories 
		select: [ :each | each handlesClass: aClass ])
		do: [ :each | each addChangeRecord: (ICRemoveClassChangeRecord for: aClass) ]! !

!ICRepositoryManager methodsFor: 'private' stamp: 'DeboraFortini 10/4/2011 11:42'!
removeMethod: aMethodReference
	(self repositories 
		select: [ :each | each handlesMethod: aMethodReference ])
		do: [ :each | each addChangeRecord: (ICRemoveMethodChangeRecord for: aMethodReference) ]	! !

!ICRepositoryManager methodsFor: 'accessing' stamp: 'EstebanLorenzano 1/19/2011 11:45'!
removeRepository: aRepository
	self repositories remove: aRepository.
	self announce: (ICRepositoryRemovedAnnouncement repository: aRepository)! !

!ICRepositoryManager methodsFor: 'accessing' stamp: 'EstebanLorenzano 1/17/2011 22:00'!
repositories 
	^repositories! !

!ICRepositoryManager methodsFor: 'accouncing' stamp: 'EstebanLorenzano 1/19/2011 16:59'!
resetAnnouncer 
	announcer := nil! !

!ICRepositoryManager methodsFor: 'initialization' stamp: 'EstebanLorenzano 1/19/2011 11:53'!
unregisterForListenEvents
	SystemChangeNotifier uniqueInstance 
		noMoreNotificationsFor: self! !

!ICRepositoryManager methodsFor: 'private' stamp: 'DeboraFortini 10/4/2011 11:42'!
updateClass: aClass 
	(self repositories 
		select: [ :each | each handlesClass: aClass ])
		do: [ :each | each addChangeRecord: (ICUpdateClassChangeRecord for: aClass) ]! !

!ICRepositoryManager methodsFor: 'private' stamp: 'DeboraFortini 10/4/2011 11:42'!
updateMethod: aMethodReference

	(self repositories 
		select: [ :each | each handlesMethod: aMethodReference ])
		do: [ :each | each addChangeRecord: (ICUpdateMethodChangeRecord for: aMethodReference) ]	! !

Object subclass: #ICSourceGenerator
	instanceVariableNames: ''
	classVariableNames: 'Default'
	poolDictionaries: ''
	category: 'Ice-Core'!

!ICSourceGenerator class methodsFor: 'accessing' stamp: 'EstebanLorenzano 1/17/2011 19:31'!
default 
	^Default ifNil: [ Default := self new ]! !

!ICSourceGenerator class methodsFor: 'accessing' stamp: 'EstebanLorenzano 1/17/2011 19:32'!
default: aGenerator
	Default := aGenerator! !

!ICSourceGenerator methodsFor: 'as yet unclassified' stamp: 'EstebanLorenzano 1/17/2011 20:02'!
installSource: sourceString
	(RWBinaryOrTextStream with: sourceString) reset fileInObjectAndCode! !

!ICSourceGenerator methodsFor: 'private' stamp: 'EstebanLorenzano 1/17/2011 19:17'!
methodExtensionsForClass: aClass container: aPackageContainer
	^(aPackageContainer packageInfo extensionMethodsForClass: aClass) 
		collect: #methodSymbol! !

!ICSourceGenerator methodsFor: 'private' stamp: 'EstebanLorenzano 1/17/2011 19:17'!
methodExtensionsForClass: aClass containers: aCollection
	^aCollection 
		inject: #()
		into: [ :all :each | all,  (self methodExtensionsForClass: aClass container: each) ]! !

!ICSourceGenerator methodsFor: 'as yet unclassified' stamp: 'EstebanLorenzano 1/17/2011 19:21'!
sourceForClass: aClass
	^String streamContents: [ :stream | 
		aClass 
			fileOutOn: stream 
			moveSource: false 
			toFile: nil ]! !

!ICSourceGenerator methodsFor: 'as yet unclassified' stamp: 'EstebanLorenzano 1/17/2011 19:17'!
sourceForClass:  aClass containers: aCollection
	| methodNames |
	
	methodNames := self methodExtensionsForClass: aClass containers: aCollection.
	^String streamContents: [ :stream | 
		methodNames do: [ :each | 
			aClass 
				printMethodChunk: each 
				withPreamble: true 
				on: stream 
				moveSource:  false 
				toFile: nil ] ]! !

!FSMemoryHandle methodsFor: '*ice-core' stamp: 'DeboraFortini 9/12/2011 15:43'!
readStream
	^ self isOpen ifTrue: [
		FSMemoryFileStream 
			on: bytes 
			store: self reference filesystem store 
			path: self reference path].! !

!String methodsFor: '*Ice-Core' stamp: 'DeboraFortini 2/11/2012 18:13'!
asFileSystemReference
	^ (self subStrings: '/') 
		inject: ((self beginsWith: '/')
			ifTrue: [ FSFilesystem disk root ] 
			ifFalse: [ FSFilesystem disk workingDirectory ])
		into: [ :dir :pathElement | dir / pathElement ]
! !
